package com.menagerie.ophelia.database.polycule.entity

import androidx.room.Embedded
import androidx.room.Entity
import androidx.room.Junction
import androidx.room.PrimaryKey
import androidx.room.Relation

@Entity
data class Polycule(
    @PrimaryKey(autoGenerate = true) val polyculeId: Long = 0,
    val polyculeName: String = "",
)

@Entity(primaryKeys = ["polyculeId", "id"])
data class PolyculeBioCrossRef(
    val polyculeId: Long,
    val id: Int,
)

data class PolyculeWithBios(
    @Embedded val polycule: Polycule,
    @Relation(
        parentColumn = "polyculeId",
        entityColumn = "id",
        associateBy = Junction(PolyculeBioCrossRef::class)
    )
    val bios: List<Bio>
)

data class BioWithPolycules(
    @Embedded val bio: Bio,
    @Relation(
        parentColumn = "id",
        entityColumn = "polyculeId",
        associateBy = Junction(PolyculeBioCrossRef::class)
    )
    val polycules: List<Polycule>
)