package com.menagerie.ophelia.database.polycule.entity

import androidx.lifecycle.LiveData
import androidx.room.Dao
import androidx.room.Delete
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Transaction
import androidx.room.Update
import androidx.room.Upsert
import com.menagerie.ophelia.database.polycule.entity.Polycule
import com.menagerie.ophelia.database.polycule.entity.PolyculeWithBios
import kotlinx.coroutines.flow.Flow

@Dao
abstract class PolyculeDao {

    @Delete
    abstract fun delete(polycule: Polycule)

    @Query("SELECT * FROM Polycule")
    abstract fun getAllPolycules(): Flow<List<Polycule>>

    @Query("SELECT * FROM Polycule WHERE polyculeId = :polyculeId")
    abstract fun getPolycule(polyculeId: Long): Flow<Polycule>

    @Upsert
    abstract suspend fun upsert(polycule: Polycule): Long

    @Transaction
    @Query("SELECT * FROM Polycule")
    abstract fun getPolyculesWithBios(): LiveData<List<PolyculeWithBios>>

}