package com.menagerie.ophelia.database.polycule.entity.viewmodel

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.asLiveData
import androidx.lifecycle.viewModelScope
import com.menagerie.ophelia.database.polycule.PolyculeDatabaseManager
import com.menagerie.ophelia.database.polycule.entity.Bio
import com.menagerie.ophelia.view.PolyculeNavHost
import kotlinx.coroutines.launch


class BioListViewModel() : ViewModel() {

    val allBios: LiveData<List<Bio>> =
        PolyculeDatabaseManager.polyculeRepository.getAllBios().asLiveData()

    fun upsert(bio: Bio) = viewModelScope.launch {
        PolyculeDatabaseManager.polyculeRepository.upsertBio(bio)
    }

    fun delete(bio: Bio) = viewModelScope.launch {
        PolyculeDatabaseManager.polyculeRepository.deleteBio(bio)
    }

//    fun fetch(bioId: Int) = PolyculeDatabaseManager.polyculeRepository.getBio(bioId = bioId).asLiveData()

    class BioListViewModelFactory() :
        ViewModelProvider.Factory {
        override fun <T : ViewModel> create(modelClass: Class<T>): T {
            if (modelClass.isAssignableFrom(BioListViewModel::class.java)) {
                @Suppress("UNCHECKED_CAST")
                return BioListViewModel() as T
            }
            throw IllegalArgumentException("Unknown ViewModel Class")
        }
    }
}

class InputBioViewModel : ViewModel() {
    private var _bio: MutableLiveData<Bio> = MutableLiveData(Bio())
    var bio: LiveData<Bio> = _bio
    fun onNameChange(name: String) {
        _bio.value?.name ?: name
    }
}