package com.menagerie.ophelia.view.polycule

import android.annotation.SuppressLint
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.material3.Button
import androidx.compose.material3.Scaffold
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.getValue
import androidx.compose.runtime.livedata.observeAsState
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.setValue
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import androidx.lifecycle.viewmodel.compose.viewModel
import com.menagerie.ophelia.database.polycule.entity.Polycule
import com.menagerie.ophelia.database.polycule.entity.viewmodel.InputPolyculeViewModel
import com.menagerie.ophelia.database.polycule.entity.viewmodel.PolyculeViewModel
import com.menagerie.ophelia.view.OpheliaFace
import com.menagerie.ophelia.view.OpheliaNewUserPolycule
import com.menagerie.ophelia.view.components.InputFieldState

@SuppressLint("UnusedMaterial3ScaffoldPaddingParameter")
@Composable
fun AddPolyculeScreen(
    onGo: () -> Unit
) {

    val inputViewModel = InputPolyculeViewModel()
    val mPolyculeViewModel: PolyculeViewModel = viewModel(
        factory = PolyculeViewModel.PolyculeViewModelFactory()
    )

    var name by remember{ mutableStateOf("") }

    Scaffold {
        Column {
            val polycule: Polycule by inputViewModel.polycule.observeAsState(Polycule())
            OpheliaFace(
                modifier = Modifier
                    .align(Alignment.CenterHorizontally)
                    .padding(top = 12.dp)
            )
            OpheliaNewUserPolycule(modifier = Modifier)
            InputFieldState(
                value = polycule.polyculeName,
                label = "name",
                placeholder = "Menagerie",
                modifier = Modifier.width(120.dp),
            ) {
                name = it
                inputViewModel.onNameChange(name)
            }
            Spacer(
                modifier = Modifier
                    .fillMaxSize()
                    .weight(1f)
            )
            Button(
                modifier = Modifier
                    .align(Alignment.End),
                onClick = {
                    insertPolyculeInDB(inputViewModel.polycule.value, mPolyculeViewModel)
                    onGo()
                }
            ) {
                Text(text = "Finish")
            }
        }
    }
}

fun insertPolyculeInDB(polycule: Polycule?, mPolyculeViewModel: PolyculeViewModel) {
    polycule?.let {
        mPolyculeViewModel.upsert(it)
    }
}

