package com.menagerie.ophelia.view.polycule

import android.annotation.SuppressLint
import android.util.Log
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.items
import androidx.compose.material3.Card
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.material3.Scaffold
import androidx.compose.material3.Text
import androidx.compose.material3.TopAppBarDefaults
import androidx.compose.runtime.Composable
import androidx.compose.runtime.collectAsState
import androidx.lifecycle.asLiveData
import androidx.lifecycle.viewmodel.compose.viewModel
import com.menagerie.ophelia.database.polycule.entity.Polycule
import com.menagerie.ophelia.database.polycule.entity.viewmodel.BioListViewModel
import com.menagerie.ophelia.database.polycule.entity.viewmodel.PolyculeViewModel

@OptIn(ExperimentalMaterial3Api::class)
@SuppressLint("UnusedMaterial3ScaffoldPaddingParameter")
@Composable
fun PolyculeDashboard(

) {
    Scaffold {
        Column {
            val scrollBehavior = TopAppBarDefaults.enterAlwaysScrollBehavior()
            val mPolyculeViewModel: BioListViewModel = viewModel(
                factory = BioListViewModel.BioListViewModelFactory()
            )

            val itemList = mPolyculeViewModel.allBios

            itemList.value?.let {
                LazyColumn{
                    items(it){
                        Card {
                            Text(text = it.name)
                        }
                    }
                }


            }
        }
    }
}
